#install.packages("meta")
library(meta)

# set wd

setwd("C:\\Users\\yourname\\yourfolder")

## Load library
library(ggplot2)
library(ggsci)
library(readxl)
library(ggpubr)
## Read Data
data <- read_excel("data.xlsx", sheet = "Cost")
data <- na.omit(data)

a1 <- metacont(n.e=n.e,mean.e = mean.e,sd.e = sd.e,n.c = n.c,mean.c = mean.c,sd.c=sd.c,data=data,method.smd="Cohen",sm="ROM",studlab=study)

tiff(filename = "Cost.tiff",width = 5000, height = 2300, res = 500, compression = "lzw")
Cost <- forest(a1,layout="JAMA",prediction=TRUE,sortvar=-TE)
dev.off()

metareg(~study,a1)

data <- read_excel("data.xlsx", sheet = "LOS")
data <- na.omit(data)

a2 <- metacont(n.e=n.e,mean.e = mean.e,sd.e = sd.e,n.c = n.c,mean.c = mean.c,sd.c=sd.c,data=data,method.smd="Cohen",sm="ROM",studlab=study)

tiff(filename = "los.tiff",width = 5000, height = 2800, res = 500, compression = "lzw")
LOS <- forest(a2,layout="JAMA",prediction=TRUE,sortvar=-TE)
dev.off()

data <- read_excel("data.xlsx", sheet = "Mortality")
data <- na.omit(data)

a3 <- metabin(event.e = mean.e, n.e=n.e,event.c = mean.c,n.c=n.c,data=data,studlab=study)

tiff(filename = "mort.tiff",width = 5000, height = 2300, res = 500, compression = "lzw")
Mort <- forest(a3,layout="JAMA",prediction=TRUE,sortvar=-TE)
dev.off()

## Funnel plots
tiff(filename = "funnel.tiff",width = 3500, height = 5000, res = 500, compression = "lzw")
par(mfrow=c(3,1))
funnel(a1, level=0.95,comb.fixed=TRUE,cex=2,cex.axis=1.5,cex.lab=1.5)
title("Hospital Cost",adj=0, cex=2)
funnel(a2, level=0.95,comb.fixed=TRUE,cex=2,cex.axis=1.5,cex.lab=1.5)
title("Length of Stay",adj=0, cex=2)
funnel(a3, level=0.95,comb.fixed=TRUE,cex=2,cex.axis=1.5,cex.lab=1.5)
title("Mortality at Discharge",adj=0, cex.lab=3)
dev.off()


metabias(a1)
metabias(a2)
metabias(a3)
